/*
 * This file is part of Bipscript.
 *
 * Bipscript is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Bipscript is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Bipscript.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef BINDAUDIO_H
#define BINDAUDIO_H

#include "squirrel.h"

namespace bipscript {

namespace audio {

namespace binding
{
    // object references to types in this package
    extern HSQOBJECT BeatTrackerObject;
    extern HSQOBJECT BufferObject;
    extern HSQOBJECT BufferEventObject;
    extern HSQOBJECT ClipObject;
    extern HSQOBJECT ConnectionObject;
    extern HSQOBJECT ConnectorObject;
    extern HSQOBJECT InputObject;
    extern HSQOBJECT MixerObject;
    extern HSQOBJECT MixerGainObject;
    extern HSQOBJECT MultiInputObject;
    extern HSQOBJECT MultiOutputObject;
    extern HSQOBJECT OnsetDetectorObject;
    extern HSQOBJECT OutputObject;
    extern HSQOBJECT StereoInputObject;
    extern HSQOBJECT StereoOutputObject;
    // method to bind this package
    void bindAudio(HSQUIRRELVM vm);
}}}

#endif // BINDAUDIO_H
