/*
 * This file is part of Bipscript.
 *
 * Bipscript is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Bipscript is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Bipscript.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef BINDMIDI_H
#define BINDMIDI_H

#include "squirrel.h"

namespace bipscript {

namespace midi {

namespace binding
{
    // object references to types in this package
    extern HSQOBJECT AbcObject;
    extern HSQOBJECT BeatTrackerObject;
    extern HSQOBJECT ClockGeneratorObject;
    extern HSQOBJECT ConnectionObject;
    extern HSQOBJECT ConnectorObject;
    extern HSQOBJECT ControlObject;
    extern HSQOBJECT CopyrightObject;
    extern HSQOBJECT CuePointObject;
    extern HSQOBJECT FileObject;
    extern HSQOBJECT InputObject;
    extern HSQOBJECT InstrumentObject;
    extern HSQOBJECT KeySignatureObject;
    extern HSQOBJECT LyricObject;
    extern HSQOBJECT MMLObject;
    extern HSQOBJECT MarkerObject;
    extern HSQOBJECT MessageEventObject;
    extern HSQOBJECT NoteObject;
    extern HSQOBJECT NoteEventObject;
    extern HSQOBJECT NoteOffObject;
    extern HSQOBJECT NoteOnObject;
    extern HSQOBJECT OutputObject;
    extern HSQOBJECT PatternObject;
    extern HSQOBJECT PitchBendObject;
    extern HSQOBJECT ProgramChangeObject;
    extern HSQOBJECT SequenceObject;
    extern HSQOBJECT SysexObject;
    extern HSQOBJECT TabObject;
    extern HSQOBJECT TempoChangeObject;
    extern HSQOBJECT TextObject;
    extern HSQOBJECT TimeSignatureObject;
    extern HSQOBJECT TrackNameObject;
    // method to bind this package
    void bindMidi(HSQUIRRELVM vm);
}}}

#endif // BINDMIDI_H
