#line 1 "extfield.yc"
#include "abcp_.h"


int abcSExtField(abcScanner *s)
{
  if (s == NULL || s->state == S_EOF) return -1;

{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_(  1,"\Y([^\s\c]+)\Y" )
        ":(<\1\200\340 \1/\200\340 \1\0>\1(\0",
    NULL};
#line 8
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {

    case -1 : return -1;

    case 1 :
              abcXField(s,key)       = YYSTART(1);
              abcXField(s,key_len)   = YYLEN(1);
              abcXField(s,code)      = abc_ChkNString(abcXField(s,key),
                                                       abcXField(s,key_len));

              if ((abcXField(s,code) & 0xD000) != 0x1000)
                 abcXField(s,code) = 0;

              abc_SetToken(s,T_XFIELD);

              switch (abcXField(s,code)) {
                case 0x1E07: /* abc-include */
                             s->nextstate = S_INCLUDE;
                             abc_SetToken(s,T_INCLUDE);
                             break;

                case 0x1E01: /* text */
                             abc_SetToken(s,T_TEXT);
                             abcText(s,type) = toupper(*YYSTART(1)); /* Text, Center, Left, Right */
                             abcText(s,string) = YYSTART(2);  /* ERROR! TO BE FIXED */
                             abcText(s,string_len) = YYLEN(2);
                             return 0;

                case 0x1F01: /* begintext */
                             s->oldstate = s->state;
                             s->nextstate = S_TEXT;
                             abc_SetToken(s,T_TEXT);
                             if (YYLEN(2)>0) {
                               /* Obeylines, Fill, Justify, Ragged, Centered */
                               abcText(s,type) = toupper(*YYSTART(2));
                             }
                             else
                               abcText(s,type) = 'T';
                             abcText(s,string_len) = 0;
                             return 0;

             #ifdef ABC_STR_MIDI
                 case 0x3001: /* midi */
                              return abc_MIDI(s);

                 case 0x3101: /* setdrum */
                             return abc_setdrum(s);
             #endif
              }
              break;
  }} /* abcStream(s */


  while (isspace(*abcCursor(s))) abcCursor(s)++;
  abcXField(s,value) = abcCursor(s)++;
  abc_gotoFieldEnd(s);
  abcXField(s,value_len)=(abcCursor(s) -1) - abcXField(s,value);

  return 0;
}

