#line 1 "field.yc"
#include "abcp_.h"


int abc_isFieldEnd(abcScanner *s)
{
  return ((*abcCursor(s) == '\0') ||
          (*abcCursor(s) == YYEOL) ||
          (abc_isInField(s) && (*abcCursor(s) == ']')));
}

void abc_gotoFieldEnd(abcScanner *s)
{
  while (*abcCursor(s) && !abc_isFieldEnd(s)) {
   if (abcCursor(s)[0] == '\\' && abcCursor(s)[1] != YYEOL &&
                                  abcCursor(s)[1] != '\0')
     abcCursor(s)++;
    abcCursor(s)++;
  }
  if (*abcCursor(s) && abc_isFieldEnd(s)) abcCursor(s)++;
}

int abcSField(abcScanner *s)
{
  if (s == NULL || s->state == S_EOF) return -1;

{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_(  1,"^?(.*)$" )
        ":-Q\2\0<\1/J\0>\1Q\3\0",
    NULL};
#line 26
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {

    case -1 : return -1;

    case 1 : abc_SetToken(s,T_FIELDB);
               if (*(s->tokstart) == '\02') { /* Skip YYSOL */
                 s->tokstart++; s->toklen--;
               }
               s->toklen--; /* Skip YYEOL */
               s->nextstate=S_TUNE;
               break;
  }} /* abcStream(s */


  return 0;
}

static int abc_FieldString(abcScanner *s,char field,unsigned short tok)
{
  int len=0;
  int res=0;

  if (abc_isFieldEnd(s)) return 0;
  abcField(s,string) = abcCursor(s);

  YYSTATE(string) {
    if (!abc_isFieldEnd(s)) {
{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_( "YYEOL", "" )
        ":Q\3\0",
_Y_(  2,"\|%" )
        ":\42Q%\0",
_Y_(  3,"\\." )
        ":Q\134J\0",
_Y_(  4,"." )
        ":J\0",
    NULL};
#line 52
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {
        case -1 : s->nextstate = S_EOF;
        case 1 : break;

        case 2 : break;

        case 3 : len++;
        case 4 : len++;  YYGOTO(string);
      }} /* abcStream(s */

    }
  }

  abcField(s,string_len) = len;

  return res;
}

/*
 0 doublewhole
 1 whole
 2 half
 3 quarter
 4 eighth
 5 sixteenth
 6 thirtysecond
 7 sixtyfourth
 8 onetwentyeighth
 */

static int abc_FieldLength(abcScanner *s)
{
 if (abc_isFieldEnd(s)) return 0;
{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_(  1,"\Y(\d+)" )
        ":(<\1D/D\0>\1\0",
    NULL};
#line 84
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ){
    case -1 : return -1;

    case 1 : abcLength(s,duration) = atoi(YYSTART(1)) * abcTICKS;
                 break;
  }} /* abcStream(s */


{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_(  1,"\Y/\Y(\d+)" )
        ":(Q/(<\1D/D\0>\1\0",
    NULL};
#line 91
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ){
    case -1 : return -1;

    case 1 : abcLength(s,duration) /= atoi(YYSTART(1));
                     break;
  }} /* abcStream(s */

  /*fprintf(stderr,"++ %d\n",abcLength(s,duration));*/
  abc_gotoFieldEnd(s);
  return 0;
}

static int abc_FieldDefine(abcScanner *s,unsigned char type)
{
  s->token=T_DEFINE;

  abcDefine(s,type) = type;
  abcDefine(s,term) = 0;
  abcDefine(s,term_len) = 0;
  abcDefine(s,definition) = 0;
  abcDefine(s,definition_len) = 0;

{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_(  1,"\Y([^\c=\y])" )
        ":(<\1\200g\1\375\377\377\376\377\377\337>\1\0",
    NULL};
#line 112
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {
    case -1 : s->nextstate = S_EOF;
            return 0;

   case 1 :
       abcDefine(s,term)=YYSTART(1);
       abcDefine(s,term_len) = YYLEN(1);
       break;
  }} /* abcStream(s */


{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_(  1,"\Y=?\Y([^\c\y])" )
        ":(-Q=\0(<\1\200d\1\375\377\377\376>\1\0",
    NULL};
#line 122
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {
    case -1 : s->nextstate = S_EOF;
            return 0;

   case 1 :
       abcDefine(s,definition)=YYSTART(1);
       abcDefine(s,definition_len) = YYLEN(1);
       break;
  }} /* abcStream(s */


  abc_gotoFieldEnd(s);
  s->nextstate = S_TUNE;
  return 0;
}

int abc_FieldMeter(abcScanner *s);
int abc_FieldTempo(abcScanner *s);
int abc_FieldKey(abcScanner *s);
int abc_FieldVoice(abcScanner *s);
int abc_FieldRhythm(abcScanner *s);


int abc_Field(abcScanner *s,unsigned char *start,char field,unsigned short tok)
{
  int res=0;

  abc_ZEROVAL(s);
  s->token = tok;
  s->val.field.field = field;
  s->tokstart=start;
  abcField(s,string)=abcCursor(s);
  abcField(s,string_len) = 0;

  while (isspace(*abcField(s,string)))
    abcField(s,string)++;

  switch (field) {
    case 'L': res = abc_FieldLength(s);
              break;

    case 'M': res = abc_FieldMeter(s);
              break;

    case 'Q': res = abc_FieldTempo(s);
              break;

    case 'R': res = abc_FieldRhythm(s);
              break;

    case 'K': res = abc_FieldKey(s);
              break;

    case 'V': res = abc_FieldVoice(s);
              break;

    case 'I': res = abcSExtField(s);
              return 0;

    case 'd': field = 's';
    case 's':
    case 'w': s->nextstate = (S_FIELD | abc_isInField(s)) | field;
              s->token=T_FIELD;
              /*while (isspace(abcCursor(s))) abcCursor(s)++;*/
              return 0;

    case 'r': abcComment(s,string) = abcCursor(s);
              abcComment(s,string_len) =0;
              abc_gotoFieldEnd(s);
              abcComment(s,string_len) = abcCursor(s) - abcComment(s,string)-1;
              s->token=T_COMMENT;
              s->nextstate = S_TUNE;
              return 0;

    case 'm':
    case 'U': return abc_FieldDefine(s,field);

    default : res = abc_FieldString(s,field,tok);
              break;
  }

  abc_gotoFieldEnd(s);

  if (abcField(s,string_len) == 0)
    abcField(s,string_len) = abcCursor(s)-abcField(s,string)-1;


  abc_clrInField(s);
  s->toklen = abcCursor(s) - s->tokstart;

  if (*(abcCursor(s)) != '\0') abcCursor(s)++;
  if (s->nextstate == S_NONE) s->nextstate = S_TUNE;
  return res;
}
