#line 1 "limbo.yc"
#include "abcp_.h"

int abcSLimbo(abcScanner *s)
{
  if (s == NULL || s->state == S_EOF) return -1;

{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_(  1,"^\Y(\a):" )
        ":Q\2(<\1G>\1Q:\0",
_Y_(  2,"^\Y%%" )
        ":Q\2(S%%\0\0",
_Y_(  3,"^\Y%(.*)" )
        ":Q\2(Q%<\1/J\0>\1\0",
_Y_(  4,"^?(.*)" )
        ":-Q\2\0<\1/J\0>\1\0",
    NULL};
#line 7
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {

    case -1 : s->nextstate=S_EOF;  return -1;

    case 1 : s->nextstate = S_TUNE;
                  return abc_Field(s,YYSTART(0),*YYSTART(1),T_FIELD);

    case 2 : return abcSExtField(s);
                  break;

    case 3 :  abc_SetToken(s,T_COMMENT);
                  abcComment(s,string)=YYSTART(1);
                  abcComment(s,string_len)=YYLEN(1)-1;
                  abcComment(s,type)='L';
                  break;

    case 4 : s->token = T_TEXT;
                  s->tokstart = YYSTART(1);
                  s->toklen = YYLEN(1);
                  abcText(s,string)=YYSTART(1);
                  abcText(s,string_len)=YYLEN(1)-1;
                  abcText(s,type)='T';
                  break;
  }} /* abcStream(s */

  return 0;
}


int abcSText(abcScanner *s)
{
  unsigned short k;
  if (s == NULL || s->state == S_EOF) return -1;

{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_(  1,"^\Y%%\Y(textend).*" )
        ":Q\2(S%%\0(<\1Stextend\0>\1/J\0\0",
_Y_(  2,"^\Y%%\Y(endtext).*" )
        ":Q\2(S%%\0(<\1Sendtext\0>\1/J\0\0",
_Y_(  3,"^.*" )
        ":Q\2/J\0\0",
    NULL};
#line 40
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {

    case -1 : s->nextstate=S_EOF;  return -1;

    case 1 :
    case 2 : if (s->oldstate != S_NONE) {
                              s->nextstate=s->oldstate;
                              s->oldstate=S_NONE;
                            }
                            s->tokstart = YYSTART(0)+1;
                            s->toklen = YYLEN(1)-2;
                            abc_SetToken(s,T_ENDTEXT);
                            break;

    case 3 : s->token = T_TEXT;
                            s->tokstart = YYSTART(0)+1;
                            s->toklen = YYLEN(1)-2;
                            abcText(s,string)=YYSTART(0)+1;
                            abcText(s,string_len)=YYLEN(1)-2;
                            for (k=0; k<2 && abcText(s,string_len>0) &&
                                           *abcText(s,string) == '%'; k++) {
                              abcText(s,string)++;
                              abcText(s,string_len)--;
                            }
                            break;
  }} /* abcStream(s */


  return 0;
}
