#line 1 "midi.yc"
#include "abcp_.h"
#if defined(ABC_STR_INSTRUMENT)
unsigned short abc_getinstrument(unsigned char *i, unsigned short l)
{
  unsigned char str[ABC_MAXLEN_STR+1];
  unsigned short k;

  if (l>ABC_MAXLEN_STR) return 0;

  k=0;

  while (l-- && (k<ABC_MAXLEN_STR)) {
    if (isalnum(*i)) str[k++] = *i;
    i++;
  }
  str[k]='\0';
  k= abc_ChkString(str);
  if ((k & 0xDF00) != 0x0800) k=0;
  return k;
}
#endif

/* %%setdrum 38 note=^e head=x */

int abc_setdrum (abcScanner *s)
{
  unsigned short n=0;

  s->token=T_SETDRUM;

  abcPercussion(s,instr)=NULL;
  abcPercussion(s,instr_len)=0;
  abcPercussion(s,head)=NULL;
  abcPercussion(s,head_len)=0;

{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_( "YYEOL", "" )
        ":Q\3\0",
_Y_(  2,"\Y(\N)" )
        ":(<\1#>\1\0",
_Y_(  3,"\Y([\w_-]+)" )
        ":(<\1\205\213\4 \0\0\0\0\0\200/\205\213\4 \0\0\0\0\0\200\0>\1\0",
    NULL};
#line 36
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {
    case -1 : s->nextstate = S_EOF;
    case 1 : return 0;

    case 2 : n=atoi(YYSTART(1));
               break;

    case 3 :
        abcPercussion(s,instr)=YYSTART(1);
        abcPercussion(s,instr_len)=YYLEN(1);
        n = abc_getinstrument(abcPercussion(s,instr),abcPercussion(s,instr_len));
        break;
  }} /* abcStream(s */

  abcPercussion(s,midiPitch)=n & 0x00FF;
  abcPercussion(s,instrCode)=n;

  YYSTATE(args) {
/*    fprintf(stderr,"%s\n",abcCursor(s));fflush(stderr);*/
 if (abc_isFieldEnd(s)) YYGOTO(done);
{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_(  1,"\Ynote\Y=\Y([_^]*)([A-Ga-g])([',]*)" )
        ":(Snote\0(Q=(<\1/\213\13\300\0>\1<\2\210\14\376\0\0\0\376>\2<\3/\204\5\200\20\0>\3\0",
_Y_(  2,"\Ystems?=\Y([uUdDnN])\a+" )
        ":(Sstem\0-Qs\0Q=(<\1\210\16\20@ \0\20@ >\1G/G\0\0",
_Y_(  3,"\Yhead\Y=\Y([\w-]+)" )
        ":(Shead\0(Q=(<\1\205\213\4 \0\0\0\0\0\200/\205\213\4 \0\0\0\0\0\200\0>\1\0",
_Y_(  4,".\Y" )
        ":J(\0",
    NULL};
#line 55
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {
     case -1 : s->nextstate = S_EOF;
            YYGOTO(done);

     case 1 :
             abcPercussion(s,notePitch) = toupper(*YYSTART(2));
             abcPercussion(s,accidentals)='n';
             if (YYLEN(1) > 0)
               abcPercussion(s,accidentals) = *YYSTART(1) == '_'?'f':'s';
             if (YYLEN(1) > 1)
              abcPercussion(s,accidentals) = toupper(abcPercussion(s,accidentals));

             n=YYLEN(3);
              abcPercussion(s,octave)=4;
              if (islower(*YYSTART(2))) abcPercussion(s,octave)++;
             while (n > 0) {
              abcPercussion(s,octave) += (YYSTART(3)[--n] == ','? -1: 1);
             }
             YYGOTO(args);

     case 2 :
              abcPercussion(s,stem) = toupper(*YYSTART(1));
              break;

     case 3 :
               *cl = '%';
               abcPercussion(s,headCode) = 0x0000;
               YYSTRNCPY(cl+1,1,ABC_MAXLEN_STR);
               n = abc_ChkString(cl);
               /*fprintf(stderr,"%04X %s",n,cl);fflush(stderr);*/
               abcPercussion(s,head)=YYSTART(1);
               abcPercussion(s,head_len)=YYLEN(1);
               if ((n & 0xFFF0) == 0x2EF0)
                 abcPercussion(s,headCode) = n;
              YYGOTO(args);

     case 4 : YYGOTO(args);
    }} /* abcStream(s */

  }

  YYSTATE(done) {
   return 0;
  }
}

int abc_MIDI (abcScanner *s)
{
  unsigned short n;
  unsigned char str[ABC_MAXLEN_STR+10];

  s->token=T_MIDI;

  abcMidi(s,cmd)=0;
  abcMidi(s,argsA)=NULL;
  abcMidi(s,argsA_len)=0;
  abcMidi(s,argsB)=NULL;
  abcMidi(s,argsB_len)=0;
  abcMidi(s,cmdstr)=NULL;
  abcMidi(s,cmdstr_len)=0;
  abcMidi(s,argc)=0;

{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_( "YYEOL", "" )
        ":Q\3\0",
_Y_(  2,"\Y(\l+)\Y" )
        ":(<\1B/B\0>\1(\0",
    NULL};
#line 116
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {
   case -1 : s->nextstate = S_EOF;
   case 1 : return 0;

   case 2 :
            /*YYFPRINTN(stderr,YYSTART(0),YYLEN(0)); fflush(stderr);*/
            abcMidi(s,cmdstr)=YYSTART(1);
            abcMidi(s,cmdstr_len)=YYLEN(1);
           *str='&';
              YYSTRNCPY(str+1,1,ABC_MAXLEN_STR);
              abcMidi(s,cmd) = abc_ChkNString(str,YYLEN(1)+1);
              /*fprintf(stderr,"%s 0x%04X\n",str,abcMidi(s,cmd)); fflush(stderr);*/
              break;
  }} /* abcStream(s */


  if (abcMidi(s,cmd) == 0x0000) { /* unknown midi command */
    abcMidi(s,argsA)=abcCursor(s);
    abc_gotoFieldEnd(s);
    abcMidi(s,argsA_len) = abcCursor(s) - abcMidi(s,argsA) -1;
    return 0;
  }

  YYSTATE (args) {
    if (abc_isFieldEnd(s)) YYGOTO(done);
    n = 0xFFFF;

{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_(  1,"\Y(\d+)" )
        ":(<\1D/D\0>\1\0",
_Y_(  2,"\Y([\w_-]+)" )
        ":(<\1\205\213\4 \0\0\0\0\0\200/\205\213\4 \0\0\0\0\0\200\0>\1\0",
_Y_(  3,"." )
        ":J\0",
    NULL};
#line 142
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {
     case -1 : s->nextstate = S_EOF;
            YYGOTO(done);

      case 1 :  n= atoi(YYSTART(1));
                  break;

      case 2 :
                   if (abcMidi(s,argsA) == NULL) {
                     abcMidi(s,argsA) = YYSTART(1);
                  abcMidi(s,argsA_len)=YYLEN(1);
                   }
                  #if defined(ABC_STR_INSTRUMENT)
                   else if (abcMidi(s,cmd) == 0x301C) { /* drum */
                     n= abc_getinstrument(YYSTART(1),YYLEN(1));
                     if (n == 0) n=0xFFFF;
                   }
                  #endif

     case 3 :        break;
    }} /* abcStream(s */


   if (abcMidi(s,argc)<20 && (n != 0xFFFF))
    abcMidi(s,argv)[abcMidi(s,argc)++]=n&0x00FF;

  YYGOTO(args);
  }

  YYSTATE (done) {
    abc_gotoFieldEnd(s);
    return 0;
  }
}
