#line 1 "rhythm.yc"
#include "abcp_.h"

int abc_FieldMeter(abcScanner *s);
int abc_FieldTempo(abcScanner *s);

int abc_FieldRhythm(abcScanner *s)
{
  abcTFieldRhythm rhythm;
  unsigned char field;
  unsigned int inF=abc_isInField(s);

  memset(&rhythm,0,sizeof(abcTFieldRhythm));
  rhythm.string = abcCursor(s);

  rhythm.field = 'R';
  if (s == NULL || s->state == S_EOF) return -1;

  if (abc_isFieldEnd(s)) YYGOTO(done);
{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_(  1,"\W" )
        ":)\0",
    NULL};
#line 19
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {
    case -1 : s->nextstate=S_EOF; YYGOTO(done);

    case 1 : rhythm.name = YYSTART(0);
            rhythm.name_len = YYLEN(0);
            /*
            YYFPRINTN(stderr,rhythm.name,rhythm.name_len);
            fputc('\n',stderr);fflush(stderr);
            */
            break;
  }} /* abcStream(s */

  YYSTATE(rhythm) {
    if (abc_isFieldEnd(s)) YYGOTO(done);
{ /* abcStream(s */
    static const unsigned char *_Y[] = {
_Y_(  1,"\[\Y([MQ]):" )
        ":Q[(<\1\211\12 \2>\1Q:\0",
_Y_(  2,"\Y(\N)\Y,?\Y(\N)\Y" )
        ":(<\1#>\1(-Q,\0(<\2#>\2(\0",
_Y_(  3,".\Y" )
        ":J(\0",
    NULL};
#line 32
    switch (yyswitch((unsigned char **)_Y,abcStream(s)) ) {
      case -1 : s->nextstate=S_EOF; YYGOTO(done);


      case 1 : abc_setInField(s);
                      field = *YYSTART(1);
                      abc_Field(s,YYSTART(0),field,T_FIELD);
                      if (!inF) abc_clrInField(s);
                      /*fprintf(stderr,"[%c]\n",field);*/
                      if (field == 'M') {
                        rhythm.hasMeter = 1;
                        memcpy(&(rhythm.meter),&(s->val.field_M),sizeof(abcTFieldMeter));
                      }
                      else {
                        rhythm.hasTempo = 1;
                        memcpy(&(rhythm.tempo),&(s->val.field_Q),sizeof(abcTFieldTempo));
                      }
                      break;

      case 2 :
                      if (rhythm.pairs < ABC_RHYTHM_MAXPAIRS) {
                        rhythm.velocity[rhythm.pairs] = atoi(YYSTART(1));
                        rhythm.duration[rhythm.pairs] = atoi(YYSTART(2));
                        rhythm.pairs++;
                      }
                      break;

      case 3 : break;
    }} /* abcStream(s */

    YYGOTO(rhythm);
  }

  YYSTATE(done) {
    memcpy(&(s->val.field_R),&rhythm,sizeof(abcTFieldRhythm));
    return 0;
  }

}
