/*
 * This file is part of handrumr.lv2.
 *
 * handrumr.lv2 is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * handrumr.lv2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with handrumr.lv2.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef MATHFUNC_H
#define MATHFUNC_H

#include <algorithm>
#include <math.h>

namespace bipscript {
namespace math {
class Math {
  public:
    static long long abs(long long value) { return std::abs(value); }
    static float abs(float value) { return std::abs(value); }
    static float acos(float value) { return std::acos(value); }
    static float asin(float value) { return std::asin(value); }
    static float atan(float value) { return std::atan(value); }
    static float atan2(float x, float y) { return std::atan2(x, y); }
    static float cbrt(float cubed) { return std::cbrt(cubed); }
    static int ceil(float value) { return std::ceil(value); }
    static float cos(float value) { return std::cos(value); }
    static float exp(float value) { return std::exp(value); }
    static int floor(float value) { return std::floor(value); }
    static float log(float value) { return std::log(value); }
    static float log10(float value) { return std::log10(value); }
    static float max(float x, float y) { return std::max(x, y); }
    static float min(float x, float y) { return std::min(x, y); }
    static float pow(float base, float exp) { return std::pow(base, exp); }
    static int round(float value) { return std::round(value); }
    static float sin(float value) { return std::sin(value); }
    static float sqrt(float squared) { return std::sqrt(squared); }
    static float tan(float value) { return std::tan(value); }
    // constants
    static float E() { return M_E; }
    static float PI() { return M_PI; }
};
} // namespace math
} // namespace bipscript
#endif // MATHFUNC_H
