/*
 * This file is part of Bipscript.
 *
 * Bipscript is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Bipscript is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Bipscript.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef MODULE_MIDI_H
#define MODULE_MIDI_H

#include "refcountable.h"
#include <stdexcept>

namespace bipscript {
namespace midi {

class Note : public RefCountable<Note> {
    const uint8_t value;
    const uint8_t vel;
    const float mduration;
    const uint8_t mchannel;

  public:
    Note(uint8_t pitch, uint8_t velocity, float duration, uint8_t channel = 0)
        : value(pitch), vel(velocity), mduration(duration), mchannel(channel) {}
    uint8_t pitch() const { return value; }
    uint8_t velocity() const { return vel; }
    float duration() const { return mduration; }
    uint8_t channel() const { return mchannel; }
};

} // namespace midi
} // namespace bipscript

#endif // MIDIOUTPUT_H
