/*
 * This file is part of Bipscript.
 *
 * Bipscript is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Bipscript is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Bipscript.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef REFCOUNTABLE_H
#define REFCOUNTABLE_H

namespace bipscript {

template <class T> class RefCountable {
    unsigned int refcount;

  public:
    RefCountable() : refcount(0) {}
    RefCountable(const RefCountable &other) { this->refcount = 0; }
    T *addref() {
        refcount++;
        return static_cast<T *>(this);
    }
    unsigned int delref() { return --refcount; }
};

} // namespace bipscript
#endif // REFCOUNTABLE_H
